package be.iminds.ilabt.jfed.experimenter_gui.slice;

import be.iminds.ilabt.jfed.experiment.ExperimentController;
import be.iminds.ilabt.jfed.experimenter_gui.canvas.rspec.CanvasNodeFactory;
import be.iminds.ilabt.jfed.experimenter_gui.config.JFedGuiConfig;
import be.iminds.ilabt.jfed.experimenter_gui.dialogs.JFedBrowserFactory;
import be.iminds.ilabt.jfed.experimenter_gui.slice.actions.ExperimentActionsFactory;
import be.iminds.ilabt.jfed.experimenter_gui.util.BrowserUtil;
import be.iminds.ilabt.jfed.experimenter_gui.util.RDPAppUtil;
import be.iminds.ilabt.jfed.experimenter_gui.util.SSHTerminalUtil;
import be.iminds.ilabt.jfed.highlevel.tasks.HighLevelTaskFactory;
import be.iminds.ilabt.jfed.highlevel.util.AggregateManagerWrapperFactory;
import be.iminds.ilabt.jfed.lowlevel.user.GeniUserProvider;
import be.iminds.ilabt.jfed.lowlevel.testbed_info.TestbedInfoSource;
import be.iminds.ilabt.jfed.lowlevel.authority.finder.AuthorityFinder;
import be.iminds.ilabt.jfed.rspec_fx.model.javafx_impl.FXModelRspec;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Singleton;

/**
 * User: twalcari
 * Date: 12/8/2014
 * Time: 14:15
 */
@Singleton
public class SliceExperimentCanvasFactory {
    @Nonnull private final JFedGuiConfig config;
    @Nonnull private final CanvasNodeFactory canvasNodeFactory;
    @Nonnull private final GeniUserProvider geniUserProvider;
    @Nonnull private final TestbedInfoSource testbedInfoSource;
    @Nonnull private final AuthorityFinder authorityFinder;
    @Nonnull private final HighLevelTaskFactory hltf;
    @Nonnull private final NodePropertiesDialogFactory nodePropertiesDialogFactory;
    @Nonnull private final ExperimentActionsFactory experimentActionsFactory;
    @Nonnull private final SSHTerminalUtil sshTerminalUtil;
    @Nonnull private final RDPAppUtil rdpAppUtil;
    @Nonnull private final AggregateManagerWrapperFactory aggregateManagerWrapperFactory;
    @Nonnull private final BrowserUtil browserUtil;
    @Nonnull private final JFedBrowserFactory jFedBrowserFactory;

    @Inject
    public SliceExperimentCanvasFactory(@Nonnull JFedGuiConfig config,
                                        @Nonnull CanvasNodeFactory canvasNodeFactory,
                                        @Nonnull GeniUserProvider geniUserProvider,
                                        @Nonnull TestbedInfoSource testbedInfoSource,
                                        @Nonnull AuthorityFinder authorityFinder,
                                        @Nonnull HighLevelTaskFactory hltf,
                                        @Nonnull NodePropertiesDialogFactory nodePropertiesDialogFactory,
                                        @Nonnull ExperimentActionsFactory experimentActionsFactory,
                                        @Nonnull SSHTerminalUtil sshTerminalUtil,
                                        @Nonnull RDPAppUtil rdpAppUtil,
                                        @Nonnull AggregateManagerWrapperFactory aggregateManagerWrapperFactory,
                                        @Nonnull BrowserUtil browserUtil,
                                        @Nonnull JFedBrowserFactory jFedBrowserFactory) {
        this.config = config;
        this.canvasNodeFactory = canvasNodeFactory;
        this.geniUserProvider = geniUserProvider;
        this.testbedInfoSource = testbedInfoSource;
        this.authorityFinder = authorityFinder;
        this.hltf = hltf;
        this.nodePropertiesDialogFactory = nodePropertiesDialogFactory;
        this.experimentActionsFactory = experimentActionsFactory;
        this.sshTerminalUtil = sshTerminalUtil;
        this.rdpAppUtil = rdpAppUtil;
        this.aggregateManagerWrapperFactory = aggregateManagerWrapperFactory;
        this.browserUtil = browserUtil;
        this.jFedBrowserFactory = jFedBrowserFactory;
    }

    public SliceExperimentCanvas createSliceExperimentCanvas(ExperimentController experimentController, FXModelRspec model) {
        return new SliceExperimentCanvas(experimentController, model, config, canvasNodeFactory, experimentActionsFactory, geniUserProvider,
                testbedInfoSource, authorityFinder, hltf, nodePropertiesDialogFactory, sshTerminalUtil, rdpAppUtil, aggregateManagerWrapperFactory,
                config, browserUtil, jFedBrowserFactory);
    }
}
